package cn.wch.ch934xuartdemo;

import android.app.Dialog;
import android.bluetooth.BluetoothDevice;
import android.content.Context;
import android.hardware.usb.UsbDevice;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;

import java.util.ArrayList;
import java.util.List;
import java.util.zip.Inflater;

public class DeviceListDialog extends Dialog {
    public Context mContext;
    public DeviceListDialog self;
    public ListView listView;
    public Button cancel;
    public ArrayList<UsbDevice> deviceArrayList;
    UsbDeviceAdapter adapter;
    public MainActivity par;
    public DeviceListDialog(Context context, int themeResId, ArrayList<UsbDevice> usbDeviceArrayList,MainActivity par) {
        super(context, themeResId);
        mContext=context;
        self=this;
        this.par=par;
        deviceArrayList=usbDeviceArrayList;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        init();

    }

    public void init(){
        View view = LayoutInflater.from(mContext).inflate(R.layout.dialog_devicelist, null);
        setContentView(view);
        listView=(ListView)view.findViewById(R.id.list);
        cancel=(Button)view.findViewById(R.id.cancel);
        adapter=new UsbDeviceAdapter(mContext,R.layout.dialog_devicelist_item,deviceArrayList);
        listView.setAdapter(adapter);
        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                UsbDevice usbDevice=adapter.getItem(position);
                par.openDevice(usbDevice);
                self.dismiss();
            }
        });
        cancel.setOnClickListener(listener);

    }
    public View.OnClickListener listener=new View.OnClickListener() {
        @Override
        public void onClick(View v) {
            self.dismiss();
        }
    };
    public class UsbDeviceAdapter extends ArrayAdapter<UsbDevice>{

        public Context mContext;
        public ArrayList<UsbDevice> usbDevices;
        public UsbDeviceAdapter(Context context,int textViewResourceId,ArrayList<UsbDevice> objects) {
            super(context,textViewResourceId,objects);
            usbDevices=objects;
            mContext=context;
        }
        @Override
        public int getCount() {
            return usbDevices.size();
        }

        @Override
        public UsbDevice getItem(int position) {
            return usbDevices.get(position);
        }

        @Override
        public long getItemId(int position) {
            return position;
        }


        @Override
        public View getView(int position,View convertView,ViewGroup parent) {
            final FieldReferences fields;
            final UsbDevice device = usbDevices.get(position);
            if (convertView == null) {
                convertView = LayoutInflater.from(mContext).inflate(R.layout.dialog_devicelist_item, null);
                fields = new FieldReferences();
                fields.deviceVIDPID=(TextView)convertView.findViewById(R.id.VPID);
                fields.deviceTYPE=(TextView)convertView.findViewById(R.id.Type);
            }else{
                fields = (FieldReferences) convertView.getTag();
            }
            fields.deviceVIDPID.setText(String.format("%04x:%04x", device.getVendorId(), device.getProductId()));
            fields.deviceTYPE.setText(device.getDeviceName());
            return  convertView;

        }
        private class FieldReferences {
            TextView deviceVIDPID;
            TextView deviceTYPE;
        }
    }


}
