package cn.wch.ch934xuartdemo;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.hardware.usb.UsbDevice;
import android.os.Handler;
import android.os.Message;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;
import org.greenrobot.eventbus.ThreadMode;

import java.util.ArrayList;
import java.util.Locale;
import java.util.Timer;
import java.util.TimerTask;

import cn.wch.lib.CH934XUARTDriver;

public class MainActivity extends AppCompatActivity implements View.OnClickListener{

    Context mContext;
    CH934XUARTDriver ch934XUARTDriver;
    UsbDevice usbDevice;
    Handler handler;
    MainActivity self;
    private Button open;
    private Button config;
    private Button clear;
    private Button write;
    private Spinner sp_baud,sp_stop,sp_data,sp_flow,sp_parity,sp_comNo;
    private int baud;
    private int Cfg_ComNo=0;
    private byte stop,data,flow,parity;
    private TextView Recv0,Recv1,Recv2,Recv3;
    private EditText Send;
    Boolean IsOpen=false;

    int Num0=0,Num1=0,Num2=0,Num3=0;
    public Timer timer;
    public TimerTask timerTask;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        mContext=this;
        self=this;
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        InitUI();
        if (!UsbFeatureSupported())// 是否支持USB HOST
        {
            Dialog dialog = new AlertDialog.Builder(MainActivity.this)
                    .setTitle("提示")
                    .setMessage("设备不支持USB HOST")
                    .setPositiveButton("确定",
                            new DialogInterface.OnClickListener() {

                                @Override
                                public void onClick(DialogInterface arg0,
                                                    int arg1) {
                                    System.exit(0);
                                }
                            }).create();
            dialog.setCanceledOnTouchOutside(false);
            dialog.show();
        }
        /*findViewById(R.id.test).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                usbDevice=ch934XUARTDriver.scanDevice().get(0);
                ch934XUARTDriver.openDevice(usbDevice);
                //ch934XUARTDriver.setConfig(usbDevice,2,115200,(byte)8,(byte)1,(byte)0,(byte)0);
                new readthread().start();
            }
        });
        findViewById(R.id.cfg).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                int ret1,ret2=0;
                ret1=ch934XUARTDriver.setConfig(usbDevice,1,115200,(byte)8,(byte)0,(byte)0,(byte)0);
                ret2=ch934XUARTDriver.setConfig(usbDevice,0,115200,(byte)8,(byte)0,(byte)0,(byte)0);
                Log.d("test",ret1+" "+ret2);
            }
        });
*/
        handler=new Handler(){
            @Override
            public void handleMessage(Message msg) {
                if(msg.what==1){
                    Recv0.setText(Num0+"");
                    Recv1.setText(Num1+"");
                    Recv2.setText(Num2+"");
                    Recv3.setText(Num3+"");
                    /*Send.setText(writenum+"");*/
                }
            }
        };
        timer=new Timer();
        timerTask=new TimerTask() {
            @Override
            public void run() {
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        Message msg = Message.obtain();
                        msg.what = 1;
                        handler.sendMessage(msg);
                    }
                });
            }
        };
        timer.schedule(timerTask,1000,1000);
        ////////////////使用EventBus来与Dialog通信

    }
    public void InitUI(){
        open=(Button)findViewById(R.id.ScanClose);
        config=(Button)findViewById(R.id.Config);
        write=(Button)findViewById(R.id.Write);
        clear=(Button)findViewById(R.id.Clear);
        Recv0=(TextView)findViewById(R.id.read_Com0);
        Recv1=(TextView)findViewById(R.id.read_Com1);
        Recv2=(TextView)findViewById(R.id.read_Com2);
        Recv3=(TextView)findViewById(R.id.read_Com3);
        Send=(EditText)findViewById(R.id.edit_write);
        open.setOnClickListener(this);
        config.setOnClickListener(this);
        write.setOnClickListener(this);
        clear.setOnClickListener(this);
        /*****ComNo*******/
        sp_comNo=(Spinner)findViewById(R.id.spinner_ComNo);
        /*****baud*******/
        sp_baud=(Spinner)findViewById(R.id.spinner_baud);
        ArrayAdapter<CharSequence> dapter=ArrayAdapter.createFromResource(this, R.array.baud, R.layout.spinner_textview);
        dapter.setDropDownViewResource(R.layout.spinner_textview);
        sp_baud.setAdapter(dapter);
        sp_baud.setSelection(9);
        baud=115200;
        /*****stop*******/
        sp_stop=(Spinner)findViewById(R.id.spinner_stop);
        ArrayAdapter<CharSequence> dapter1=ArrayAdapter.createFromResource(this, R.array.stop, R.layout.spinner_textview);
        dapter.setDropDownViewResource(R.layout.spinner_textview);
        sp_stop.setAdapter(dapter1);
        sp_stop.setSelection(0);
        stop=0;
        /******data******/
        sp_data=(Spinner)findViewById(R.id.spinner_data);
        ArrayAdapter<CharSequence> dapter2=ArrayAdapter.createFromResource(this, R.array.data, R.layout.spinner_textview);
        dapter.setDropDownViewResource(R.layout.spinner_textview);
        sp_data.setAdapter(dapter2);
        sp_data.setSelection(3);
        data=8;
        /*****parity*******/
        sp_parity=(Spinner)findViewById(R.id.spinner_parity);
        ArrayAdapter<CharSequence> dapter3=ArrayAdapter.createFromResource(this, R.array.parity, R.layout.spinner_textview);
        dapter.setDropDownViewResource(R.layout.spinner_textview);
        sp_parity.setAdapter(dapter3);
        parity=0;
        /*****flow*******/
        sp_flow=(Spinner)findViewById(R.id.spinner_flow);
        ArrayAdapter<CharSequence> dapter4=ArrayAdapter.createFromResource(this, R.array.flow, R.layout.spinner_textview);
        dapter.setDropDownViewResource(R.layout.spinner_textview);
        sp_flow.setAdapter(dapter4);
        flow=0;
    }
    void InitSpinnerComNo(int Num){
        if(Num<0){
            return;
        }
        ArrayList<String> ArrayComNo=new ArrayList<>();
        for(int i=0;i<Num;i++){
            ArrayComNo.add(String.format("%d",i));
        }
        ArrayAdapter<String> dapter2=new ArrayAdapter<String>(this,R.layout.spinner_textview,ArrayComNo);
        sp_comNo.setAdapter(dapter2);
        sp_comNo.setSelection(0);
        Cfg_ComNo=0;
    }
    public boolean UsbFeatureSupported()
    {
        boolean bool = MainActivity.this.getPackageManager().hasSystemFeature("android.hardware.usb.host");
        return bool;
    }
    @Override
    public void onClick(View v) {
        switch (v.getId()){
            case R.id.ScanClose:
                if(!IsOpen){///扫描设备
                    if(ch934XUARTDriver==null) {
                        ch934XUARTDriver = new CH934XUARTDriver(this);
                    }
                    ArrayList<UsbDevice> list=new ArrayList<>();
                    list=ch934XUARTDriver.scanDevice();
                    if(list==null || list.size()==0){
                        Toast.makeText(mContext,"未发现设备",Toast.LENGTH_SHORT).show();
                        break;
                    }else{
                        DeviceListDialog deviceListDialog=new DeviceListDialog(mContext,R.style.Theme_AppCompat_Dialog,list,self);
                        deviceListDialog.setCancelable(false);
                        deviceListDialog.show();
                    }

                    /*if(ch934XUARTDriver.openDevice(list.get(0))){

                        usbDevice=list.get(0);
                        open.setText("Close");
                        IsOpen=true;
                        InitSpinnerComNo(ch934XUARTDriver.getComNum(usbDevice));
                        Log.d("num",String.format("%04x:%04x", usbDevice.getVendorId(), usbDevice.getProductId()));
                        new readthread().start();
                    }else{
                        Toast.makeText(mContext,"打开设备失败",Toast.LENGTH_SHORT).show();
                        break;
                    }*/

                }else{///关闭设备
                    IsOpen=false;
                    ch934XUARTDriver.close();
                    ch934XUARTDriver=null;
                    open.setText("Scan");
                }
                break;
            case R.id.Config:
                if(IsOpen){
                    GetParament();
                    int ret1=ch934XUARTDriver.setConfig(usbDevice,Cfg_ComNo,baud,(byte)data,(byte)stop,(byte)parity,(byte)flow);
                    if(ret1!=0){
                        Toast.makeText(mContext,"串口"+Cfg_ComNo+" SetConfig 失败 "+ret1,Toast.LENGTH_SHORT).show();
                        break;
                    }
                    Toast.makeText(mContext,"串口"+Cfg_ComNo+" SetConfig 成功",Toast.LENGTH_SHORT).show();
                }else{
                    Toast.makeText(mContext,"设备未打开",Toast.LENGTH_SHORT).show();
                }
                break;
            case R.id.Clear:
                Num0=0;
                Recv0.setText("");
                Num1=0;
                Recv1.setText("");
                Num2=0;
                Recv2.setText("");
                Num3=0;
                Recv3.setText("");
               /* writenum=0;
                Send.setText("");*/
                break;
            case R.id.Write:
                if(IsOpen){
                    GetParament();
                    String str=Send.getText().toString().toLowerCase(Locale.getDefault());
                    byte[] mValue=parseHexToBytes(str);
                    /*while(true) {
                        int ret1 = ch934XUARTDriver.writeData(usbDevice, Cfg_ComNo, mValue);
                        if (ret1 < 0) {
                            Toast.makeText(mContext, "发送失败 " + ret1, Toast.LENGTH_SHORT).show();
                        }
                        Log.d("write","write"+ret1);
                    }*/
                    /*new writethread().start();*/
                    int ret1 = ch934XUARTDriver.writeData(usbDevice, Cfg_ComNo, mValue);
                    if (ret1 < 0) {
                        Toast.makeText(mContext, "发送失败 " + ret1, Toast.LENGTH_SHORT).show();
                    }
                }else{
                    Toast.makeText(mContext,"设备未打开",Toast.LENGTH_SHORT).show();
                }
                break;
        }
    }
    public void GetParament(){
        if(!TextUtils.isEmpty(sp_comNo.getSelectedItem().toString())) {
            Cfg_ComNo = Integer.parseInt(sp_comNo.getSelectedItem().toString());
        }
        baud = Integer.parseInt(sp_baud.getSelectedItem().toString());
        data = (byte) Integer.parseInt(sp_data.getSelectedItem().toString());
        String stopString=sp_stop.getSelectedItem().toString();
        if(stopString.equals("1")){
            stop=0x00;
        }else if(stopString.equals("1.5")){
            stop=0x04;
        }else if(stopString.equals("2")){
            stop=0x04;
        }
        String parityString = sp_parity.getSelectedItem().toString();
        if (parityString.compareTo("None") == 0) {
            parity = 0;
        }

        if (parityString.compareTo("Odd") == 0) {
            parity = 1;
        }

        if (parityString.compareTo("Even") == 0) {
            parity = 2;
        }

        if (parityString.compareTo("Mark") == 0) {
            parity = 3;
        }

        if (parityString.compareTo("Space") == 0) {
            parity = 4;
        }
        String flowString = sp_flow.getSelectedItem().toString();
        if (flowString.compareTo("None") == 0) {
            flow = 0;
        }
        if (flowString.compareTo("CTS/RTS") == 0) {
            flow= 1;
        }
    }


    private class readthread extends Thread{
        byte[] buf=new byte[4*1024];
        readthread(){
            this.setPriority(Thread.MAX_PRIORITY-3);
        }///确保及时读数据
        public void run() {
            Log.d("ThreadState", "ReadThread Start" );
            while (IsOpen) {
                if(ch934XUARTDriver==null)
                    break;
                int len = ch934XUARTDriver.readData(usbDevice, 1, buf, 4096);
                if (len > 0) {
                    /*Message msg = Message.obtain();
                    msg.obj = len;
                    msg.what = 1;
                    handler.sendMessage(msg);*/
                    Num1+=len;
                    Log.d("recv", "read:" + len);
                } else if (len < 0) {

                }
                if(ch934XUARTDriver==null)
                    break;
                int len0 = ch934XUARTDriver.readData(usbDevice, 0, buf, 4096);
                if (len0 > 0) {
                    /*Message msg = Message.obtain();
                    msg.obj = len0;
                    msg.what = 0;
                    handler.sendMessage(msg);*/
                    Num0+=len0;
                    Log.d("recv", "read0:" + len0);
                } else if (len0 < 0) {
                }
                if(ch934XUARTDriver==null)
                    break;
                int len2 = ch934XUARTDriver.readData(usbDevice, 2, buf, 4096);
                if (len2 > 0) {
                    Message msg = Message.obtain();
                    msg.obj = len0;
                    msg.what = 0;
                    handler.sendMessage(msg);
                    Num2+=len2;
                    Log.d("recv", "read0:" + len2);
                } else if (len2 < 0) {

                }
                if(ch934XUARTDriver==null)
                    break;
                int len3 = ch934XUARTDriver.readData(usbDevice, 3, buf, 4096);
                if (len3 > 0) {
                    Message msg = Message.obtain();
                    msg.obj = len0;
                    msg.what = 0;
                    handler.sendMessage(msg);
                    Num3+=len3;
                    Log.d("recv", "read0:" + len3);
                } else if (len3 < 0) {

                }
            }
            Log.d("ThreadState", "ReadThread End--->Num-->" + "Com0:"+Num0 + "Com1:"+Num1
                    + "Com2:"+Num2 + "Com3:"+Num3);
        }

    }
    long writenum=0;
    private class writethread extends Thread{
        byte[] mValue=new byte[]{0x33,0x34};
        public void run() {
            while(IsOpen) {
                int ret1 = ch934XUARTDriver.writeData(usbDevice, Cfg_ComNo, mValue);
                if(ret1<0){
                    break;
                }
                writenum+=ret1;
            }
            Log.d("ThreadState", "WriteThread End" + writenum);
        }
    }
    public void openDevice(UsbDevice usbDevice){
        this.usbDevice=usbDevice;
        if(ch934XUARTDriver.openDevice(usbDevice)){
            open.setText("Close");
            IsOpen=true;
            InitSpinnerComNo(ch934XUARTDriver.getComNum(usbDevice));
            Log.d("num",String.format("%04x:%04x", usbDevice.getVendorId(), usbDevice.getProductId()));
            new readthread().start();
        }else{
            Toast.makeText(mContext,"打开设备失败",Toast.LENGTH_SHORT).show();
        }
    }
    @Override
    protected void onDestroy() {
        IsOpen=false;
        if(ch934XUARTDriver!=null){
            ch934XUARTDriver.close();
        }
        if(timerTask!=null){
            timerTask.cancel();
            timerTask=null;
        }
        if(timer!=null){
            timer.cancel();
            timer=null;
        }
        super.onDestroy();
    }
    ///////////////////////////////////
    private byte[] parseHexToBytes(final String hex) {
        String tmp = hex.substring(0).replaceAll("[^[0-9][a-f]]", "");
        byte[] bytes = new byte[tmp.length() / 2]; // every two letters in the string are one byte finally

        String part = "";

        for(int i = 0; i < bytes.length; ++i) {
            part = "0x" + tmp.substring(i*2, i*2+2);
            bytes[i] = Long.decode(part).byteValue();
        }
        return bytes;
    }

}
